$(function(){$('#progress').dialog('open');$('button').button();
var KEY_ESC=27;var KEY_ENTER=13;var $favoriteList = $('#favorites');var $favoriteEdit = $('#favorite-edit');var $favoriteSaveBtn = $('.favorite-save-btn');var $favoriteCancelBtn = $('.favorite-cancel-btn');var $channelList = $('#all-channels');var originalFavorites=cloneIgnoreID(favorites);var $channels = $('#all-channels');var $tableBody = $channels.find('tbody');function cloneIgnoreID (favorites) {return _.each(sortFavorites(_.cloneDeep(favorites)),function (f) {f.id = '';});}
function sortFavorites (favs) {_.each(favs,function (f) {f.channels=_.sortBy(f.channels, 'id');});
return _.sortBy(favs, 'name');}
function isOriginalSettingsChanged () {var currentFavorites=cloneIgnoreID(favorites);return !_.isEqual(originalFavorites,currentFavorites);}
function checkChanges () {$('#save').button('option', 'disabled', !isOriginalSettingsChanged());}
function getCurrentFavorite () {return _.find(favorites, {id: $favoriteList.find(':selected').val()});}
function updateFavoriteList (selectID) {$favoriteList.empty();var sortedFavorites=_.sortBy(favorites,function (f) {return f.name.toLocaleLowerCase();});
_.each(sortedFavorites,function (favorite) {$favoriteList.append(
$('<option />')
.attr('selected', selectID == favorite.id)
.val(favorite.id)
.text(favorite.name)
);});
var favoritesExists=sortedFavorites.length > 0;$('.favorite-edit-btn').button('option', 'disabled', !favoritesExists);$('.favorite-remove-btn').button('option', 'disabled', !favoritesExists);$favoriteList.prop('disabled', !favoritesExists);(favoritesExists ? $.fn.removeClass : $.fn.addClass).call(
$favoriteList, 'disabled'
);updateChannelList();}
function updateChannelList () {var $checkboxes = $channelList.find('.channel-active')
.prop('checked', false);var $activeGroup = $channelList.find('.active-group')
.prop('checked', false);$channelList.find('tr.active').removeClass('active');
var currentFavorite=getCurrentFavorite();if(!currentFavorite){$checkboxes.prop('disabled', true);$activeGroup.prop('disabled', true);}else{$checkboxes.prop('disabled', false);$activeGroup.prop('disabled', false);_.each(currentFavorite.channels, function (channel) {var $tr = $channelList
.find('tr[data-id="'+channel.id+'"]');$tr.addClass('active');
$tr.find('.channel-active').prop('checked', true);});
$('.active-group')
.prop('checked', currentFavorite.channels.length > 0);}
checkChanges();}
function saveExists (favorites,newName) {var currentFavorite=getCurrentFavorite();currentFavorite.name=newName;return currentFavorite.id;};
function saveNew (favorites,newName) {var id=createGUID();favorites.push({name: newName,
id: id,
channels: []});return id;};
function onFavoriteEdit (val,saveFunc) {$favoriteEdit.val(val);$favoriteEdit.off();
$favoriteCancelBtn.off();$favoriteSaveBtn
.button('option', 'disabled', val.length < 1)
.off();$channelList.find('.channel-active')
.prop('checked', false)
.prop('disabled', true);$channelList.find('.active-group')
.prop('checked', false)
.prop('disabled', true);$channelList.find('tr.active')
.removeClass('active');var toggleVisible=function (edit) {$('.edit').toggleClass('hidden');if(edit){$('.form-group').find('button').addClass('hidden');$('.edit-group').find('button').removeClass('hidden');}else{$('.form-group').find('button').removeClass('hidden');$('.edit-group').find('button').addClass('hidden');}};var save=_.bind(function(){var newName = $favoriteEdit.val();if(newName.length < 1){return;}
var id=saveFunc(favorites,newName);updateFavoriteList(id);
toggleVisible(false);}, this);var cancel=_.bind(function(){toggleVisible(false);updateChannelList();}, this);$favoriteSaveBtn.on('click', save);$favoriteCancelBtn.on('click', cancel);$favoriteEdit.on('keydown', function (event) {if(event.keyCode==KEY_ESC){return cancel();}if(event.keyCode==KEY_ENTER){return save();}});$favoriteEdit.on('keyup', function (event) {$favoriteSaveBtn.button(
'option', 'disabled', $(this).val().length < 1
);});
toggleVisible(true);$favoriteEdit.focus();}
function sortTable ($el, sortFunc) {$('.sort-active').removeClass('sort-active');$el.addClass('sort-active');
var reverse = $el.hasClass('reverse');var rows = $tableBody.children('tr').detach();rows.sort(sortFunc(reverse ? -1 : 1));$(rows).each(function(){$tableBody.append($(this));});
$el.toggleClass('reverse');$tableBody.scrollTop(0);}
$('.favorite-add-btn').on('click', function(){onFavoriteEdit('', saveNew);});
$('.favorite-edit-btn').on('click', function(){onFavoriteEdit($favoriteList.find(':selected').text(),saveExists);});
$('.favorite-remove-btn').on('click', function(){var currentFavorite=getCurrentFavorite();favorites=_.without(favorites,currentFavorite);updateFavoriteList();});$favoriteList.on('change', function(){updateChannelList();});
$channelList
.on('change', '.channel-active', function (event) {var $el = $(this);var isActive = $el.prop('checked');var channelID=Number($el.closest('tr').attr('data-id'));var currentFavorite=getCurrentFavorite();if(!currentFavorite){return;}
var $row = $el.closest('tr');if(isActive){var obj = {id: channelID};if(!_.find(currentFavorite.channels, obj)){currentFavorite.channels.push(obj);}
$row.addClass('active');}else{currentFavorite.channels=_.without(
currentFavorite.channels,
_.find(currentFavorite.channels, {id: channelID})
);$row.removeClass('active');}
checkChanges();})
.on('click', 'tbody tr', function (event) {var $active = $(this).find('.channel-active');if(!$(event.target).is($active) && !$active.prop('disabled')){$active.prop('checked', !$active.prop('checked')).change();}});$('#save')
.on('click', function(){var $saveForm = $('#save-form');$saveForm.find('[name=courier]').val(
JSON.stringify(favorites));$saveForm.submit();})
updateFavoriteList();$('a:not([href^="#"], [target])').on('click', function (e) {if(isOriginalSettingsChanged()){e.preventDefault();exit_url = $(this).attr('href');$('div#exit-warn').dialog('open');
return false;}
return true;});
$('.channels-sort-num').on('click', function(){sortTable($(this),function (desc) {return function (row1,row2) {var a=parseInt($(row1).find('.channel-num-row').text());var b=parseInt($(row2).find('.channel-num-row').text());a=a == -1 ? Infinity * desc : a;b=b == -1 ? Infinity * desc : b;return (a > b ? 1 : -1) * desc;};});return false;});
$('.channels-sort-name').on('click', function(){sortTable($(this),function (desc) {return function (row1,row2) {return $(row1).find('.channel-name-row').text()
.toLowerCase().localeCompare(
$(row2).find('.channel-name-row').text().toLowerCase()) * desc;};});return false;});
$('.active-group').on('change', function(){$('.channel-active')
.prop('checked', $(this).prop('checked'))
.change();});
$('.channel-active').on('change', _.throttle(function(){$('.active-group')
.prop('checked', $('.channel-active:checked').length > 0);}, 100)).change();$('#cancel').button('option', 'disabled', false);$('.favorite-add-btn').button({icons: {primary: 'ui-icon-plus'}});$('.favorite-edit-btn').button({icons: {primary: 'ui-icon-pencil'}});$('.favorite-remove-btn').button({icons: {primary: 'ui-icon-trash'}});$('.favorite-save-btn').button({icons: {primary: 'ui-icon-disk'}});$('.favorite-cancel-btn').button({icons: {primary: 'ui-icon-cancel'}});$(window).bind('beforeunload', function(){$('#progress').dialog('open');});
initStandardTabs();$('#progress').dialog('close');});