(function ($) {'use strict';$.fn.directoryTree=function (param) {var caller=this;if(typeof param === 'object' || !param){var options=param;var onLoadedProxy=options.onLoaded;options.onLoaded=function (e) {var currentPath=caller.data('tree').getDirectory();var $selectButton = $('<a class="dl-select" href="#"><span class="ui-icon ui-icon-check"></span> <span>'+options.selectLabel+'</span></a>')
.appendTo(this.find('.dl-tree-footer'))
.addClass(currentPath.length > 0 ? '' : 'dl-disabled')
.on('click', function(){if($(this).hasClass('dl-disabled')){return false;}
var result = {path: currentPath};if(options.selectFiles){result.files = $.map($(caller).find('.dl-tree .checkbox.ischecked'), function (el) {return $(el).closest('.dl-tree-leaf').attr('id');});}
$(caller).trigger($.Event('change-path', result));return false;});if(options.selectFiles){var generalSelect=function(){$(this).find('.checkbox')
.toggleClass('ischecked isunchecked');$selectButton.toggleClass('dl-disabled', $leafs.find('.checkbox.ischecked').length < 1);};
var select=options.selectFiles == 'multiple' ? generalSelect :
options.selectFiles == 'single' ? function(){$leafs.find('.checkbox.ischecked')
.removeClass('ischecked')
.addClass('isunchecked');generalSelect.call(this);
setTimeout(function(){$selectButton.click();}, 200);} : function(){};var $leafs = $(this).find('.dl-tree a:not([hc])')
.on('click', select);$('<span class="checkbox ui-icon isunchecked"></span>')
.prependTo($leafs)
$selectButton.addClass('dl-disabled');}if(!options.selectFiles){$('<a class="dl-make-directory" href="#"><span class="ui-icon ui-icon-folder-open"></span> <span>'+options.makeDirectoryLabel+'</span></a>')
.appendTo(this.find('.dl-tree-footer'))
.addClass(currentPath.length > 0 ? '' : 'dl-disabled')
.on('click', function(){if($(this).hasClass('dl-disabled')){return false;}
caller.data('tree').makeDirectory();return false;});}if(onLoadedProxy){onLoadedProxy.call(this,e);}};var t=new Tree(caller,options);t.createTree();
caller.data('tree', t);t.getDirectory=function(){var path;var currentPath=t.getCurrentPath();var isWindows=options.pathDelimiter == '\\';var result = (path = $.map(currentPath,function (item) {return item.replace(/:\\$/, ':');}).join(options.pathDelimiter)) ? path + options.pathDelimiter : '';if(!isWindows){result = '/' + result;}
return result;};
t.showServerError=function(){$(caller).find('.dl-tree-content')
.empty()
.append('<div class="dl-error-message ui-widget-content ui-corner-all ui-state-error">Server error</div>');};
t.changeDirectory=function (path) {if(path.length < 1){return false;}if(!RegExp('^[A-z]{1}:[\\\\/]$').test(path)){path=path.replace(/[\/\\]+$/, '');}
var windowsPath=path.split(':\\');var res = [];if(windowsPath.length > 1){if(windowsPath[1].length < 1) {t.changePath.call(t, [], path);return true;}
res.push(windowsPath[0] + ':\\');path=windowsPath[1];}
res=res.concat(path.split(options.pathDelimiter));var filtered = [];for(var i in res){if(res[i].length > 0) {filtered.push(res[i]);}}
res=filtered;var last=res.splice(-1)[0];t.changePath.call(t,res,last)
.fail(function(){t.changePath.call(t, [], '')
.fail(function(){t.showServerError();});});return true;};
t.makeDirectory=function(){var $footer = $('.dl-tree-footer', caller);var $controls = $footer.find('*').hide();var $newControls =  $('<form>').appendTo($footer)
.on('submit', function(){if($createButton.hasClass('dl-disabled')){return false;}
var newDirectoryName = $newDirectoryName.val();$newDirectoryName
.removeClass('ui-state-error')
.blur();$createButton.addClass('dl-disabled');
$createDirControls.addClass('dl-disabled');$.ajax({url: options.makeDirectoryUrl,
type: 'POST',
dataType: 'json',
data: {directory: newDirectoryName,
path: t.getDirectory()},
success: function (response) {t.changePath(t.getCurrentPath(),newDirectoryName);},
complete: function(){$createDirControls.removeClass('dl-disabled');},
error: function(){$newDirectoryName
.addClass('ui-state-error')
.focus();setTimeout(function(){$newDirectoryName
.removeClass('ui-state-error');}, 1500);}});return false;});
var $createButton = $('<a class="dl-create-directory" href="#"><span class="ui-icon ui-icon-folder-open"></span> <span>'+options.createLabel+'</span></a>')
.appendTo($newControls)
.addClass('dl-disabled')
.on('click', function(){$newControls.submit();return false;});
function cancel () {if($(this).hasClass('dl-disabled')){return false;}
$newControls.remove();$controls.show();
return false;}
var $cancelButton = $('<a class="dl-cancel-directory" href="#"><span class="ui-icon ui-icon-folder-open"></span> <span>'+options.cancelLabel+'</span></a>')
.appendTo($newControls)
.on('click', function(){return cancel();});
var $newDirectoryName = $('<input type="text" class="dl-directory-name text ui-widget-content ui-corner-all" />')
.appendTo($newControls)
.on('keydown', function (event) {if($(this).hasClass('dl-disabled')){return false;}if(event.keyCode==27){return cancel();}})
.on('keyup', function (event) {if(event.keyCode==13){return false;}
$createButton.toggleClass('dl-disabled', $(this).val().length < 1);})
.focus();var $createDirControls = $newDirectoryName.add($cancelButton).add($createButton);};if(!options.path){t.initTree();}else{t.changeDirectory(options.path);}}else{var t=caller.data('tree');if(!t) return;return t[param].apply(this, Array.prototype.slice.call(arguments,1));}
return caller;};
var PathSelector=function (element,options){this.isShown=false;this.options=options;this.$element = $(element);}
PathSelector.DEFAULTS = {template: '<div class="path-selector" role="path-selector"><div class="path-selector-tree"></div></div>',
manualEditButtonTemplate: '<div class="path-manual-edit">E</div>',
pathDelimiter: '\\'};PathSelector.prototype.changeDirectory=function (path) {this.$tree.tree('changeDirectory', path)};PathSelector.prototype.show=function (path) {if(this.isShown){return;}
var self=this;this.oldPath=path;this.isShown=true;this.$element.wrap('<div class="path-selector-wrapper"></div>');$('<div class="clearfix"></div>').insertAfter(this.$element);this.$pathSelector = $(this.options.template).insertAfter(this.$element);this.$pathManualEditButton = $(this.options.manualEditButtonTemplate).insertAfter(this.$element);var data = {};if(this.options.selectFiles){data.files=true;}
this.$pathManualEditButton.on('click', function(){self.hide();self.$element.focus().select();
return false;});
var $tree=this.$tree=this.$pathSelector.find('.path-selector-tree')
.directoryTree($.extend({}, {data: data,
breadcrumb: true,
backButton: true,
separator: this.options.pathDelimiter,
path: path,
selectLabel: 'Select',
makeDirectoryLabel: 'New directory',
createLabel: 'Create',
cancelLabel: 'Cancel',
maxHeight: 200,
onLoaded: $.proxy(function(){this.$element.val($tree.tree('getDirectory')).change();}, this)}, this.options))
.on('change-path', $.proxy(function (event) {this.hide.call(this);this.$element.val(event.path).change();}, this));$(document).on('click.dismiss.ps', $.proxy(function (event) {if(this.$pathSelector.has($(event.target)).length){return false;}
event.preventDefault();this.hide.call(this);
this.$element.val(this.oldPath);this.$element.trigger($.Event('canceled'));
return false;}, this));};
PathSelector.prototype.hide=function(){if(!this.isShown){return;}
this.isShown=false;$(document).off('click.dismiss.ps');
this.$pathSelector.remove();if(this.$pathManualEditButton){this.$pathManualEditButton.remove();this.$pathManualEditButton=null;}
this.$element.unwrap();};
$.fn.pathSelector=function (option,_relatedTarget) {return this.each(function(){var $this = $(this);var data = $this.data('ps');var options = $.extend(
{},
PathSelector.DEFAULTS,
$this.data(),
typeof option == 'object' && option
);if(!data){data=new PathSelector(this,options);$this.data('ps', data);}if(typeof option == 'string'){data[option](_relatedTarget);}else if(options.show){data.show(_relatedTarget);}});}
$.fn.pathSelector.Constructor=PathSelector;$(document).on('click.ps.data-api', '[data-toggle="path-selector"]', function (event) {var $input = $(this);var options = {pathDelimiter: $input.data('delimiter'),
selectFiles: $input.data('files'),
url: $input.data('url'),
makeDirectoryUrl: $input.data('new-dir-url')};var manualEdit = $input.data('manual-edit');if(manualEdit){if(manualEdit.startsWith('.') || manualEdit.startsWith('#')) {manualEdit = $(manualEdit).html();}
options.manualEditButtonTemplate=manualEdit;}
var labels = $input.data('labels');labels=labels ? labels.split(';') : [];if(labels.length === 6){$.extend(options, {backLabel: labels[0],
breadcrumbRootLabel: labels[1],
selectLabel: labels[2],
makeDirectoryLabel: labels[3],
createLabel: labels[4],
cancelLabel: labels[5]});}
var $t = $.fn.pathSelector.call($input, options);$t.trigger($.Event('show'));
$t.pathSelector('show', $(event.target).val());event.preventDefault();});}(jQuery));