checkersQueueEnable();$(function(){var UPDATE_INTERVAL=1000;var UPDATE_ATTEMPT=10;var OBSERVATION_LENGTH=150;$('#progress').dialog('open');
var sourceTemplate = $('#source-tmpl').html();var chartsOptions = {series: {shadowSize: 0,
color: 'rgba(13, 13, 13, 0.5)',
lines: {lineWidth: 1,
show: true,
fill: true,
fillColor: 'rgba(13, 13, 13, 0.1)'}},
xaxis: {min: 0,
max: OBSERVATION_LENGTH-1,
show: false},
yaxis: {min: 0},
grid: {backgroundColor: {colors: ['#fff', '#eee']},
borderWidth: 1}};var selectedState = {openedSourceSid: [],
selectedStreamSid: '',
selectedStreamCid: ''};var bitrateData, errorsData;var bitrateChart = $.plot('#chart-bitrate', [], chartsOptions);var errorsChart = $.plot('#chart-errors', [], chartsOptions);var chartsIsBlank=true;var sourcesElement = $('#sources')
.on('click', '.source.filled .header', function(){$(this).closest('.source').toggleClass('opened');selectedState.openedSourceSid = $('.source.opened')
.map(function (i,e) {return $(e).attr('data-sid');});})
.on('change', '[name=selector]', function(){var tr = $(this).closest('tr');var cid=tr.attr('data-cid');var sid=tr.closest('.source').attr('data-sid');if(selectedState.selectedStreamSid !== sid ||
selectedState.selectedStreamCid !== cid){selectedState.selectedStreamSid=sid;selectedState.selectedStreamCid=cid;resetChartsData();}});function sortSources(sourceList){return _.sortBy(sourceList,function (source) {return source.source_instance_name.toLowerCase();});}
function makeSourceHtml(sourceObject){return _.template(sourceTemplate,sourceObject);}
function updateSourceList(sourceList,selected){sourceList=sortSources(sourceList);sourcesElement.empty();
_.each(sourceList,function (source) {this.append(makeSourceHtml(source));}, sourcesElement);if(!selectedState.selectedStreamSid && !selectedState.selectedStreamCid){var sourceElement=sourcesElement
.find('.source.filled:first').addClass('opened');var selectElement=sourcesElement
.find('[name=selector]:first').prop('checked', true).change();var trElement=selectElement.closest('tr');var sid=sourceElement.attr('data-sid');selectedState.openedSourceSid=sid ? [sid] : [];selectedState.selectedStreamSid=trElement.closest('.source').attr('data-sid') || '';selectedState.selectedStreamCid=trElement.attr('data-cid') || '';}else{$.each(selected.openedSourceSid, function (i,e) {sourcesElement
.find('.source.filled[data-sid="'+e+'"]').addClass('opened');});
sourcesElement
.find('.source.filled[data-sid="'+selected.selectedStreamSid+'"]')
.find('tr[data-cid="'+selected.selectedStreamCid+'"]')
.find('[name=selector]').prop('checked', true).change();}}
function resetChartsData(){bitrateData=_.map(new Array(OBSERVATION_LENGTH),function(){return 0;});
errorsData=_.clone(bitrateData);}
function fillChartData(data,chart){var chartData, i, l;for(chartData=[], i=0, l=data.length;i<l; ++i){chartData.push([i, data[i]]);}
chart.setData([chartData]);chart.setupGrid();
chart.draw();}
function cleanCharts(){if(!chartsIsBlank){resetChartsData();visibleYAxes(bitrateChart,false);visibleYAxes(errorsChart,false);fillChartData([], bitrateChart);fillChartData([], errorsChart);chartsIsBlank=true;}}
function visibleYAxes(chart,show){chart.getOptions().yaxes[0].show=show;}
function updateCharts(sources){var currentSource=_.filter(sources,function (source) {return !_.isEmpty(selectedState) &&
source.source_id.toString() === selectedState.selectedStreamSid.toString();});if(currentSource.length < 1){cleanCharts();return;}
var currentStream=_.filter(currentSource[0].streams, function (stream) {return stream.channel_id.toString() === selectedState.selectedStreamCid.toString();});if(currentStream.length < 1){cleanCharts();return;}
currentStream=currentStream[0];bitrateData.shift();
bitrateData.push(currentStream.stat.bitrate);errorsData.shift();
errorsData.push(currentStream.stat.error_packet_count);fillChartData(bitrateData,bitrateChart);visibleYAxes(bitrateChart,true);fillChartData(errorsData,errorsChart);visibleYAxes(errorsChart,true);chartsIsBlank=false;}
var updateAttempt=UPDATE_ATTEMPT;function startUpdate(){(function(){var func=arguments.callee;$.ajax({async: true,
url: 'param',
data: {},
dataType : 'json',
timeout: 60000,
type: 'POST',
success: function (data,textStatus) {updateAttempt=UPDATE_ATTEMPT;updateSourceList(data,selectedState);updateCharts(data);
setTimeout(func,UPDATE_INTERVAL);if(checkersQueue.enabled){checkersQueue.enabled=false;checkersInit();}},
error: function(){if(!--updateAttempt){show_info(l.c.internal_error);return;}
setTimeout(func,UPDATE_INTERVAL);},
complete: function(){$('#progress').dialog('close');}});})();}
startUpdate();$(window).bind('beforeunload', function(){$('#progress').dialog('open');});});