function init () {var KEY_ESC=27;var KEY_ENTER=13;var currentLang=BOOTSTRAP.language;var storageName = 'translate=' + currentLang;var rowHeight;var currentCatalog=BOOTSTRAP.catalog;var $table = $('.cfg-strings');var currentLang=BOOTSTRAP.language;var translateObject=JSON.parse(window.localStorage.getItem(storageName)) || {};var $controlButtons = $('.ms-controls .normal-button');var sendSuccessMessage = $('#send-success-tmpl').text();function simpleText ($element) {return $element.text();}
function viewElementToPlainObject (field, $element) {if(_.contains(['id', 'reference', 'translate'], field)){return simpleText($element);}}
function plainObjectToShowObject (field,value) {if(_.contains(['id', 'reference', 'translate'], field)){return value;}
return undefined;}
function editElementToPlainObject (field, $element) {if(_.contains(['id', 'reference'], field)){return simpleText($element);}if(field === 'translate'){return $element.val();}}
function setTranslate ($row, sid, translate) {translateObject=JSON.parse(window.localStorage.getItem(storageName)) || {};var component = $components.find(':selected').val();if(!(component in translateObject)){translateObject[component] = {};}
var originalTranslate=_.find(currentCatalog, {id: sid}).translate;if(translate==originalTranslate){if(translateObject[component][sid]) {delete translateObject[component][sid];}
$row.removeClass('cfg-changed');$row.find('.cfg-string-translate')
.removeAttr('title');}else{translateObject[component][sid] = translate;$row.addClass('cfg-changed');
$row.find('.cfg-string-translate')
.attr('title', originalTranslate);}
$row.find('.cfg-string-translate').text(translate);window.localStorage.setItem(storageName, JSON.stringify(translateObject));updateControlsState();}
function updateTable (catalog,component) {_.each(translateObject[component], function (text,sid) {_.find(catalog, {id: sid}).changed=true;});
table.setData(_.sortBy(catalog, 'changed'));_.each(translateObject[component], function (text,sid) {var $row = $table.find('[data-sid="' + sid + '"]');$row.addClass('cfg-changed');
var $translate = $row.find('.cfg-string-translate');$translate
.attr('title', $translate.text())
.text(text);});
updateControlsState();}
function getCurrentComponent () {return $components.find(':selected').val();}
function getChangedTranslate () {var component=getCurrentComponent();var translations=translateObject[component];return _.isEmpty(translations) ? null : {cid: component,
translations: translations};}
function updateControlsState () {var translations=getChangedTranslate();$controlButtons.prop('disabled', !translations ? 'disabled' : '');}
var table=new Table($table, {rowTemplate: _.template($('#target-row-tmpl').html()),
editRowTemplate: _.template($('#target-edit-row-tmpl').html()),
emptyTableHelp: _.template($('#empty-table-help-tmpl').html()),
viewElementToPlainObject: viewElementToPlainObject,
editElementToPlainObject: editElementToPlainObject,
plainObjectToShowObject: plainObjectToShowObject,
onRowSelect: function ($row) {},
onBeforeEdit: function ($row) {rowHeight =  $row.outerHeight();},
onEdit: function ($row) {$row.find('textarea')
.focus()
.select()
.css({height: rowHeight - 13});},
onBeforeSave: function ($row) {return true;},
onSave: function ($row, isSave) {var translate = $row.find('.cfg-string-translate').text().trim();var sid = $row.find('.cfg-string-id').text();setTranslate($row, sid, translate);},
onUpdateRowView: function ($row) {if(!$row){return;}
$row.find('.tbl-edit').button({icons: {primary: 'ui-icon-pencil'},
text: false});$row.find('.tbl-save').button({icons: {primary: 'ui-icon-disk'},
text: false});$row.find('.tbl-cancel').button({icons: {primary: 'ui-icon-cancel'},
text: false});$row.find('.cfg-translate-reset').button({icons: {primary: 'ui-icon-cancel'},
text: false});},
onAction: function ($el, $row) {if($el.is('.cfg-translate-reset')){var sid = $row.find('.cfg-string-id').text();var originalTranslate=_.find(currentCatalog, {id: sid}).translate;setTranslate($row, sid, originalTranslate);}}});var $components = $('.cfg-components').on('change', function(){var component = $(this).find(':selected').val();$('#progress').dialog('open');
$.ajax({async: true,
url: './catalog/',
dataType : 'json',
data: {component: component},
timeout: 60000,
type: 'POST',
success: function (catalog) {currentCatalog=catalog;updateTable(currentCatalog,component);$.cookie('l10n.cmpn', component);},
error: function (xhr,textStatus) {showInfo(xhr.responseText || l.c.internal_error);},
complete: function(){$("#progress").dialog('close');}});});
updateTable(currentCatalog,getCurrentComponent());$('#main-reset-btn').on('click', function(){$('#progress').dialog('open');setTimeout(function () {var component=getCurrentComponent();translateObject[component] = {}
updateTable(currentCatalog,component);window.localStorage.setItem(storageName, JSON.stringify(translateObject));$('#progress').dialog('close');});});
$('#main-send-btn').on('click', function(){$('#progress').dialog('open');var translations=getChangedTranslate();$.ajax({async: true,
url: './send/',
dataType : 'json',
data: {component: translations.cid,
lang: currentLang,
translations: JSON.stringify(translations.translations)},
timeout: 60000,
type: 'POST',
success: function(){showInfo(sendSuccessMessage, 'info');},
error: function (xhr,textStatus) {showInfo(xhr.responseText || l.c.internal_error);},
complete: function(){$("#progress").dialog('close');}});});
$table.on('keydown', '.cfg-string-translate-field', function (event) {var $tr = $(this).closest('tr');if(event.keyCode==KEY_ENTER){var $trs = $table.find('tbody tr');var index = $trs.index($tr);$tr.find('.tbl-save').click();
setTimeout(function(){var $nextTr = $($trs.get(index + 1));$nextTr.find('.tbl-edit').click();}, 50);return false;}if(event.keyCode==KEY_ESC){$tr.find('.tbl-cancel').click();return false;}});$('#progress').dialog('close');};$(function(){$('#progress').dialog('open');setTimeout(init);});