function Share ($tab, changedCallback) {var self=this;this._$table = $tab.find('.cfg-templates tbody');this._rowTemplate=_.template($('#share-row-tmpl').html());$tab.on('click', '.cfg-new-share-templates-btn', _.bind(function(){this._editShareTemplate('', '', '', false, false);}, this));this._$editDialog = $tab.find('.cfg-share-edit-dlg').show();this._$editDialog.dialog({autoOpen: false,
modal: true,
draggable: false,
resizable: false,
closeText: '',
width: 420,
closeOnEscape: false});this._$editDialog.on('click', '.cfg-share-edit-cancel', _.bind(function(){this._$editDialog.dialog('close');}, this));this._$editDialog.on('click', '.cfg-share-edit-apply', _.bind(function(){var param = {id: this._$editDialog.find('#tid').val(),
name: this._$editDialog.find('#name-ctrl').val(),
text: this._$editDialog.find('#text-ctrl').val(),
built_in: false,
default_text: this._$editDialog.find('#default-text-ctrl').prop('checked')};if(!param.id){param.id=createGUID();this._addTemplateToList(param);}else{var tr = $('tr#' + param.id, this._$table);$('.cfg-share-row-name', tr).text(param.name).prop('title', param.name);$('.cfg-share-row-text', tr).text(param.text).prop('title', param.text);var $dt = $('.cfg-share-row-default-text', tr);if(param.default_text){$dt.addClass('cfg-on').prop('title', $dt.data('yes'));}else{$dt.removeClass('cfg-on').prop('title', $dt.data('no'));}}
this._$editDialog.dialog('close');changedCallback();}, this));this._$editDialog.on('change', '.cfg-share-macros', function(){var $text=self._$editDialog.find('#text-ctrl')
insertAtCaret($text, $(this).val());$(this).val('insert');
$text.focus();});
$tab.on('click', '.cfg-share-row-remove', function(){$(this).closest('tr').remove();changedCallback();});$tab.on('click', '.cfg-share-row-edit', function(){var tr = $(this).closest('tr');self._editShareTemplate(
tr.attr('id'),
$('.cfg-share-row-name', tr).text(),
$('.cfg-share-row-text', tr).text(),
$('.cfg-share-row-builtin', tr).hasClass('cfg-on'),
$('.cfg-share-row-default-text', tr).hasClass('cfg-on'),
tr.attr('original-text')
);});}
Share.prototype._createTemplateItem=function (template) {var newTrElement = $(this._rowTemplate(template));newTrElement.find('.cfg-share-row-remove').button({icons: {primary: 'ui-icon-trash'},
text: false});newTrElement.find('.cfg-share-row-edit').button({icons: {primary: 'ui-icon-pencil'},
text: false});return newTrElement;};
Share.prototype._addTemplateToList=function (template) {this._$table.append(this._createTemplateItem(template));};
Share.prototype._fillMacrosBox=function (macros) {var $macros=this._$editDialog.find('.cfg-share-macros');$macros.empty();
$('<option/>')
.val('insert')
.prop('disabled', true)
.prop('selected', true)
.text($macros.data('placeholder'))
.appendTo($macros);_.each(macros,function (section) {var optgroupElement = $('<optgroup/>').attr('label', section.name);_.each(section.macros, function (macro) {$('<option/>')
.val(macro.macro)
.text(macro.name)
.appendTo(optgroupElement);});
optgroupElement.appendTo($macros);});};Share.prototype.open=function (loadComplete) {return $.ajax({url: './sharetemplates/',
data: {},
dataType : 'json',
timeout: 60000,
type: 'POST',
success: _.bind(function (data,textStatus) {this._$table.empty();_.each(data.templates, this._addTemplateToList, this);this._fillMacrosBox(data.macros);}, this),
complete: loadComplete});};
Share.prototype.save=function(){var templateElement=this._$table.find('tr');var templates=_.map(templateElement,function (tr) {tr = $(tr);return {id: tr.attr('id'),
name: $('.cfg-share-row-name', tr).text(),
text: $('.cfg-share-row-text', tr).text(),
builtin: $('.cfg-share-row-builtin', tr).hasClass('cfg-on'),
defaultText: $('.cfg-share-row-default-text', tr).hasClass('cfg-on')};});
return $.ajax({url: './savesharetemplates/',
data: {templates: JSON.stringify(templates)},
dataType : 'json',
timeout: 60000,
type: 'POST'});};
Share.prototype._editShareTemplate=function (id,name,text,builtin,defaultText,originalText) {var $editScreen=this._$editDialog.dialog('open');var $nameCtrl=this._$editDialog.find('#name-ctrl');var $textCtrl=this._$editDialog.find('#text-ctrl');this._$editDialog.find('#tid').val(id);
name=name ? name : $nameCtrl.data('default');if(text){$editScreen.data('customText', text);}else{text = $textCtrl.data('default');$editScreen.data('customText', text);}
$nameCtrl.val(name);$textCtrl.val(text);
var $insertCtrl = $editScreen.find('.cfg-share-macros');$editScreen.find('#builtin-ctrl').prop('checked', builtin);function setTextCtrlEnabled (defaultTextCtrl) {var isDefaultText=defaultTextCtrl.prop('checked');$textCtrl
.prop('disabled', isDefaultText);$insertCtrl.prop('disabled', isDefaultText);return isDefaultText;};
$editScreen.find('.cfg-default-text-item')
.css('display', builtin ? 'block' : 'none');var $defaultTextCtrl = $editScreen.find('#default-text-ctrl');$defaultTextCtrl
.prop('checked', defaultText && builtin)
.prop('disabled', !builtin)
.off('change.connect.settings.change.macros')
.on('change.connect.settings.change.macros', function(){var isDefaultText=setTextCtrlEnabled($defaultTextCtrl);if(isDefaultText && originalText){$editScreen.data('customText', $textCtrl.val());$textCtrl.val(originalText);}else{$textCtrl
.val($editScreen.data('customText'));}})
.change();};
$(function(){$('#progress').dialog('open');$('button#main-save-btn, button#main-cancel-btn')
.button('option', 'disabled', true);$(window).bind('beforeunload', function(){$('#progress').dialog('open');});
var changed=false;var share=new Share($('.cfg-settings-share'), function(){$('button#main-save-btn, button#main-cancel-btn')
.button('option', 'disabled', false);changed=true;hookExitLinks();});share.open(function(){$('#progress').dialog('close');});
$('#main-cancel-btn').click(function(){if(!changed){return true;}
window.location.reload();});
$('#main-save-btn').click(function(){$('#progress').dialog('open');share.save()
.done(function(){window.location.reload();})
.always(function(){$('#progress').dialog('close');})
.error(function(){showInfo(l.c.internal_error);});});});