(function ($, undefined) {var Connect=window.Connect || (window.Connect = {});var Views=Connect.Views || (Connect.Views = {});var PROGRAM_UPDATE_INTERVAL=5 * 1000;var MANUAL_RECORD_DURATION=3 * 60;var AUTO_HIDE_EXTEND_INFO_DELAY=5 * 1000;var DEINTERLACE = [
{name: 'Disabled', id: 'disabled'},
{name: 'Enabled', id: 'enabled'}
];function scaleCanvas (canvas,width,height) {var w=canvas.width,
h=canvas.height;if(width==undefined){width=w;}if(height==undefined){height=h;}
var retCanvas=document.createElement('canvas');var retCtx=retCanvas.getContext('2d');retCanvas.width=width;retCanvas.height=height;retCtx.drawImage(canvas,0,0,w,h,0,0,width,height);return retCanvas;}
var ChimPlayer=Views.ChimPlayer=Backbone.View.extend({_player: null,
_$player: null,
_$audioTracks: null,
_$subTracks: null,
actions: {toggleFullScreen: function(){this._player.fullscreen(!this._player.fullscreen());},
toggleWindowScreen: function(){this.toggleFullWindow();},
stop: function(){this.stop();},
stopIfNotFullscreen: function(){if(!this._player.fullscreen()){this.stop();}},
showInfo: function(){this.showInfo(true);},
togglePause: function(){if(this._videoInfo instanceof Connect.Models.TVStreamInfo){return;}},
volumeUp: function(){this._player.volume(this._player.volume() + 10);},
volumeDown: function(){this._player.volume(this._player.volume() - 10);}},
constructor: function(){if(!ChimPlayer.instance){ChimPlayer.instance=this;Backbone.View.apply(ChimPlayer.instance, arguments);}
return ChimPlayer.instance;},
getCurrentDeinterlace: function(){var lastDeinterlace = $.cookie('deinterlace');var ids=_.pluck(DEINTERLACE, 'id');if(lastDeinterlace && _.includes(ids,lastDeinterlace)){return lastDeinterlace;}else{if(this._options.deinterlace && _.includes(ids, this._options.deinterlace)){return this._options.deinterlace;}}
return _.first(DEINTERLACE)['id'];},
_createPlayer: function (options) {this._options=options;var playerConteinerID = 'chim-player';this._$player = $('#' + playerConteinerID);this._hideInfoTimer=null;var wjs=Connect.common.standalone.require('wcjs-player');this._player=new wjs('#' + playerConteinerID).addPlayer({autoplay: false,
vlcArgs: []});this._player.myevents.addListener('ready', _.bind(function (mpv) {mpv.setProperty('pause', false);console.log('MPV version: ', mpv.getProperty('mpv-version'));var deinterlace=this.getCurrentDeinterlace();if(deinterlace){this._player.deinterlace(deinterlace);}}, this));this._player.myevents.addListener('playing', _.bind(function (mpv) {$spinner.hide();(this._player.audioCount() > 1 ? $.fn.show : $.fn.hide)
.call($('.wcp-audio-but'));(this._player.subCount() > 1 ? $.fn.show : $.fn.hide)
.call($('.wcp-sub-but'));(this._player.duration() < 1 ? $.fn.addClass : $.fn.removeClass).call(
this._$player, 'dbl-progress-less'
);this.showInfo();
$('body').addClass('dbl-watched');if(this._$infoLayer){this._$infoLayer.addClass('dbl-autohide');}
this.trigger('playing');}, this));this._player.myevents.addListener('stopped', _.bind(function (mpv) {$spinner.show();$('body').removeClass('dbl-watched');
this.trigger('stopped');this._clearProgramUpdateTimer();
$('.wcp-audio-but').hide();Connect.common.Keyboard.blur(this);
this.trigger('ended');setTimeout(_.bind(function(){if(this._player.fullscreen()){this._player.fullscreen(false);}
setTimeout(_.bind(function(){this.hide();$('body').removeClass('dbl-chim-player-showed');}, this), 300);}, this));}, this));this._$surface=this._$player.find('.wcp-surface');$spinner = $('<div class="dbl-waiter"/>').appendTo(
this._$surface
).hide();var $toolbar=this._$player.find('.wcp-toolbar');var $toolbarButtons = $toolbar.find('.wcp-button');$('<div class="wcp-button dbl-wcp-button wcp-left wcp-close-but"></div>')
.insertBefore($toolbarButtons.first());$('<div class="wcp-button dbl-wcp-button wcp-left wcp-record-but"></div>')
.insertBefore($toolbarButtons.first());$('<div class="wcp-button dbl-wcp-button wcp-left wcp-info-but"></div>')
.insertBefore($toolbarButtons.first());$('<div class="wcp-button dbl-wcp-button wcp-left wcp-deinterlace-but"></div>')
.insertBefore($toolbarButtons.first());$('<div class="wcp-button dbl-wcp-button wcp-right wcp-sub-but"></div>')
.insertBefore($toolbarButtons.last());$('<div class="wcp-button dbl-wcp-button wcp-right wcp-audio-but"></div>')
.insertBefore($toolbarButtons.last());$('<div class="wcp-button dbl-wcp-button wcp-right wcp-screenshot-but"></div>')
.insertBefore($toolbarButtons.last());$('<div class="dbl-record-state-osd"></div>')
.appendTo(this._$player.find('.wcp-wrapper'));$toolbar.on('click', '.wcp-close-but', _.bind(function(){this.stop();}, this));$toolbar.on('click', '.wcp-audio-but', _.bind(function(){this._togglePopupMenu(this._$audioTracks, this._showAudioTracks, this._hidePopupMenu);}, this));$toolbar.on('click', '.wcp-sub-but', _.bind(function(){this._togglePopupMenu(this._$subTracks, this._showSubTracks, this._hidePopupMenu);}, this));$toolbar.on('click', '.wcp-record-but', _.bind(function(){this._record();}, this));$toolbar.on('click', '.wcp-info-but', _.bind(function(){this.showInfo();}, this));$toolbar.on('click', '.wcp-deinterlace-but', _.bind(function(){this._togglePopupMenu(this._$deinterlaceOptions, this._showDeinterlaceOptions, this._hidePopupMenu);}, this));$toolbar.find('.wcp-screenshot-but').hide();
this._$player.on('mousemove click', _.bind(function(){this.showInfo();}, this));this._$player.on('mousedown', _.bind(function (event) {if(event.which === Connect.defaults.MouseKeys.right){this.toggleFullWindow();}}, this));var remoteJQuery=Connect.common.standalone.require('jquery');function makePreBind (jQuery) {jQuery.fn.getEvents=function(){if(typeof(jQuery._data)=='function'){return jQuery._data(this.get(0), 'events') || {};}else if(typeof(this.data)=='function'){return this.data('events') || {};}
return {};};
jQuery.fn.preBind=function(type,data,fn) {this.each(function(){var $this=jQuery(this);$this.bind(type,data,fn);var currentBindings = $this.getEvents()[type];if(jQuery.isArray(currentBindings)){currentBindings.unshift(currentBindings.pop());}});return this;};}
makePreBind(remoteJQuery);remoteJQuery('.wcp-surface').preBind('click', _.bind(function (event) {if(this._player.position() === 0){event.stopImmediatePropagation();}}, this));var oldFadeOut=remoteJQuery.fn.fadeOut;remoteJQuery.fn.fadeOut=function(){this.trigger('fadeout');oldFadeOut.apply(this,arguments);};
remoteJQuery(this._$player).find('.wcp-toolbar').on('fadeout', _.bind(function(){this.hideInfo();}, this));this._$player.find('.wcp-wrapper').on('webkitfullscreenchange', _.bind(function (event) {var isFullscreen=Boolean(window.document.webkitFullscreenElement);if(!isFullscreen){this._$player.find('.wcp-minimize')
.removeClass('wcp-minimize')
.addClass('wcp-maximize');}
$('body').toggleClass('dbl-fullscreen', isFullscreen);}, this));$(document).on('webkitfullscreenchange', _.bind(function(){this._player.aspectRatio(this._player.aspectRatio());}, this));Connect.common.Keyboard.register(this, 'chimPlayer', 70, this.actions);},
stop: function(){$spinner.show();this._player.stop();},
show: function (url,options) {if(!this._player){this._createPlayer(options);}
this._$player.show();$('body').addClass('dbl-chim-player-showed');
this._videoInfo=options.videoInfo;var enableTranscoding = $.cookie('dt') != 'true';if(enableTranscoding && this._videoInfo instanceof Connect.Models.TVStreamInfo){url+='&' + this._getTranscoderParams().join('&');}
this._player.play(url);this._hideInfo();
this.showInfo();if(this._videoInfo instanceof Connect.Models.TVStreamInfo){this._clearProgramUpdateTimer();var $recordButton=this._$player.find('.wcp-record-but');this._updateProgramRecordState($recordButton);
this._programUpdateTimer=setInterval(_.bind(function(){this._updateProgramRecordState($recordButton);}, this), PROGRAM_UPDATE_INTERVAL);}
Connect.common.Keyboard.focus(this);return this;},
hide: function(){this._$player.hide();},
clearPlaylist: function(){if(this._player.playing()){this._player.stop();}},
_hideInfo: function(){this._hideInfoTimer=null;this._$player.find('.dbl-chim-playerinfo-layer').stop().fadeOut();
this._$player.removeClass('dbl-info-showed');},
hideInfo: function (delay) {if(this._hideInfoTimer){return;}if(delay){this._hideInfoTimer=setTimeout(_.bind(this._hideInfo, this), delay);return;}
this._hideInfo();},
showInfo: function (manual) {$('.dbl-chim-playerinfo-layer').remove();var currentProgram=this._videoInfo.getCurrentProgram();this._$infoLayer = $(
_.template($('#chim-player-info-layer-tmpl').html())(
_.extend({start: null,
end: null}, currentProgram.toJSON(), {audio: this._audioDesc(this._player.audioTrack()),
subtitle: this._subDesc(this._player.subTrack())})
)
).appendTo(
this._$surface
);if(this._videoInfo instanceof Connect.Models.TVStreamInfo){this._$infoLayer.find('.dbl-duration').remove();}if(manual){this.hideInfo(AUTO_HIDE_EXTEND_INFO_DELAY);}
this._$infoLayer.addClass('dbl-extend');this._$player.addClass('dbl-info-showed');},
_subDesc: function (track) {return this._player.subDesc(track);},
_audioDesc: function (index) {var AUDIO_TRACK_DESC = 'Track';var result=AUDIO_TRACK_DESC + ' ' + (index + 1);var desc=this._player.audioDesc(index);if(desc.length > 0){result+=' (' + desc + ')';}
return result;},
_updateProgramRecordState: function ($recordButton) {var currentProgram=this._videoInfo.getCurrentProgram();var isRecord=currentProgram.get('is_record');$recordButton.toggleClass('active', isRecord);this._$player.toggleClass('dbl-is-record', isRecord);},
_clearProgramUpdateTimer: function(){if(this._programUpdateTimer){clearInterval(this._programUpdateTimer);}},
_record: function(){var currentProgram=this._videoInfo.getCurrentProgram();if(currentProgram.get('isUnknown')){this._recordManual(currentProgram);}else{this._recordByEPG(currentProgram);}},
_recordManual: function (currentProgram) {var now=moment();var channels=_.map(
this._videoInfo.get('channel').collection.models,
function (channel) {return {id: channel.id,
name: channel.get('name')};}
);var recordings=new Connect.Models.NewRecording({channel: currentProgram.get('channel_id'),
channels: channels,
date: moment(now),
daysMask: window.DAYS_MASK,
endtime: moment(now).add(MANUAL_RECORD_DURATION, 'minutes'),
starttime: moment(now),
title: this._videoInfo.get('channel').get('name') + ' [' + now.format('llll') + ']'}).on('error', function (model,xhr) {new Connect.Views.Alert().showError(xhr.responseText);});
var recordingDialog=new Connect.Views.AddRecording({model: recordings});recordings.on('sync', function(){recordingDialog.hide();var successDialog = (new (Connect.Views.Dialog.extend({template: _.template($('#record-success-tmpl').html())})));successDialog.$el.on('keydown', function (event) {event.stopImmediatePropagation();});
successDialog.showModal().always(function(){successDialog.$el.off('keydown');});});recordingDialog.$el.on('keydown', function (event) {event.stopImmediatePropagation();});
recordingDialog.showModal().always(function(){recordingDialog.$el.off('keydown');});},
_recordByEPG: function (currentProgram) {(currentProgram.get('is_record') ? currentProgram.cancelRecording : currentProgram.addRecording)
.apply(currentProgram).success(_.bind(function(){this._updateProgramRecordState(this._$player.find('.wcp-record-but'));}, this));},
_togglePopupMenu: function (popupMenu,show,hide) {if(popupMenu && popupMenu.is(':visible')){hide.call(this,popupMenu);}else{show.call(this);}},
_showPopupMenu: function (template,items,changeCallback,title) {var popup = $(_.template($(template).html())(items))
.appendTo(this._$player.find('.wcp-wrapper'));popup.show();
popup
.on('click', '.wcp-menu-item', changeCallback)
.on('click', '.wcp-menu-close', _.bind(function (event) {this._hidePopupMenu(popup);}, this));if(!_.isUndefined(title)){popup.find('.wcp-menu-title').text(title);}
return popup;},
_hidePopupMenu: function (popupMenu) {if(popupMenu){popupMenu.remove();popupMenu=null;}},
_showAudioTracks: function(){var tracks=_.map(_.range(this._player.audioCount()), _.bind(function (i) {return {id: i,
name: this._audioDesc(i)}}, this));this._$audioTracks=this._showPopupMenu('#chim-player-tracks-tmpl', {tracks: tracks,
current: this._player.audioTrack()}, _.bind(function (event) {this._player.audioTrack(parseInt($(event.currentTarget).attr('data-track-id')));this._hidePopupMenu(this._$audioTracks);}, this), 'Audio Tracks');},
_showSubTracks: function(){var tracks=_.map(_.range(this._player.subCount()), _.bind(function (i) {return {id: i,
name: this._player.subDesc(i)}}, this));this._$subTracks=this._showPopupMenu('#chim-player-tracks-tmpl', {tracks: tracks,
current: this._player.subTrack()}, _.bind(function (event) {this._player.subTrack(parseInt($(event.currentTarget).attr('data-track-id')));this._hidePopupMenu(this._$subTracks);}, this), 'Subtitles');},
_showDeinterlaceOptions: function(){this._$deinterlaceOptions=this._showPopupMenu('#chim-player-deinterlace-options-tmpl', {options: DEINTERLACE,
current: this.getCurrentDeinterlace()}, _.bind(function (event) {var deinterlace = $(event.currentTarget).attr('data-id');$.cookie('deinterlace', deinterlace, Connect.defaults.cookieParams);this._player.deinterlace(deinterlace);
this._hidePopupMenu(this._$deinterlaceOptions);}, this));},
screenshot: function(){this._capture(function (videoFrame) {Connect.common.request('/stdln/screenshot/', {image: videoFrame})
.done(_.bind(function (response) {var hideInfoTimer;var $screenshotInfo = $(
_.template($('#screenshot-info-tmpl').html())(response)).appendTo(this._$surface);$screenshotInfo.find('.dbl-screenshot-actions a').each(function(){$(this).attr('title', $(this).text());});
function hideInfo () {$screenshotInfo.fadeOut(null,function(){$screenshotInfo.remove();});
hideInfoTimer=null;}
$screenshotInfo
.on('mousemove', function(){if(hideInfoTimer){clearTimeout(hideInfoTimer);}})
.on('mouseout', function(){hideInfoTimer=setTimeout(hideInfo,3000);});
$screenshotInfo.find('.dbl-screenshot-thumbnail').attr('src', videoFrame);$screenshotInfo.find('.dbl-copy-image').on('click', function(){var image=require('native-image').createFromDataUrl(videoFrame);require('clipboard').writeImage(image);});$screenshotInfo.find('.dbl-open-link, .dbl-screenshot-filename').on('click', function(){require('shell').showItemInFolder(response.filepath);});
$screenshotInfo.find('.dbl-copy-path').on('click', function(){require('clipboard').writeText(response.filepath);});
hideInfoTimer=setTimeout(hideInfo,3000);}, this))
.fail(function (xhr,status) {new Connect.Views.Alert().showError(xhr.responseText);});});},
toggleFullWindow: function(){var on = !this._$player.hasClass('fullwindow');this._$player.toggleClass('fullwindow', on);$('body').toggleClass('dbl-fullscreen', on);this._player.aspectRatio(this._player.aspectRatio());},
_getTranscoderParams: function(){var size = ($.cookie('r') || Connect.defaults.resolution).split('x');var bitrate = $.cookie('b') || Connect.defaults.bitrate;return [
'transcoder=h264ts',
'width=' + size[0],
'height=' + size[1],
'bitrate=' + bitrate
];}});}).call(this,jQuery);(function ($, undefined) {var iframeWatchChannel=Connect.common.watchChannel;var options = {};_.extend(Connect.common, {standalone: {isStandalone: function(){var checkThisFunc=function(){try{return this === __object__;} catch(e){return false;}};var checkThis=function (obj) {return new Function(
'return (' + checkThisFunc.toString().replace('__object__', obj) + ')()'
);}
var isBrowser=checkThis('window');var isNode=checkThis('global');return isNode() && isBrowser();},
require: function (module) {var path=require('path');var electron=require('electron');var ipc=electron.ipcRenderer;return require(
path.join(
path.dirname(
ipc.sendSync('get-root-dir')
), 'node_modules', module
)
);},
getMediaServerURL: function(){if(!this.mediaServerUrl){var electron=require('electron');var ipc=electron.ipcRenderer;this.mediaServerUrl=ipc.sendSync('get-media-server-url');}
return this.mediaServerUrl;},
iframeWatchChannel: iframeWatchChannel},
watchChannel: function (channelID,isLocked,channel) {if(!Connect.common.standalone.isStandalone()){iframeWatchChannel.apply(this,arguments);return;}
var url=Connect.common.standalone.getMediaServerURL();url+='dvblink/direct?client=5696d298c9d383ab4e8beb8e40cb2e76&channel=' + channelID;(new Connect.Views.ChimPlayer()).show(url, _.extend(options, {videoInfo: new Connect.Models.TVStreamInfo({channel: channel}),}));}});if(!Connect.common.standalone.isStandalone()){$(showDVBLinkPlayerDialog);return;}
var electron=require('electron');var ipc=electron.ipcRenderer;options=ipc.sendSync('get-settings');Connect.Models.TVStreamInfo=Backbone.Model.extend({initialize: function (options) {this._channel=options.channel;},
getCurrentProgram: function(){var programs=this._channel.get('programs');var currentProgram=programs.getByTime(moment().unix());if(currentProgram){currentProgram.set('channel_name', this._channel.get('name'));currentProgram.set('channel_id', this._channel.get('id'));currentProgram.collection=this._channel.collection;}
return currentProgram;}});Connect.Models.RecordInfo=Backbone.Model.extend({initialize: function (options) {this._record=options.record;},
getCurrentProgram: function(){return this._record;}});Connect.Plugins.register({tvrecords: {watch: function (recordID,isLocked,record) {var url=Connect.common.standalone.getMediaServerURL();url+='dvblink/playback?object=' + recordID;(new Connect.Views.ChimPlayer())
.show(url, _.extend(options, {videoInfo: new Connect.Models.RecordInfo({record: record}),}));return true;}}});function adaptSettingsDialog () {var $settingsTabs = $('.dbl-settings-tabs');$('#settings-modal')
.off('show.bs.modal')
.on('show.bs.modal', function (event) {$settingsTabs.find('a[href="#global-options"]').tab('show');});if($.cookie('transcoding-set')!='true'){$.cookie('dt', 'true', Connect.defaults.cookieParams);}
var prevOptionsTab = $settingsTabs.find('#preview-options');prevOptionsTab.find('#lang').closest('.form-group').hide();
prevOptionsTab
.on('save', function(){$.cookie('transcoding-set', 'true', Connect.defaults.cookieParams);});}
function addStdlnStyles () {$('head').append($('#stdln-styles-tmpl').html());}
function showDVBLinkPlayerDialog () {var playerDialog = (new (Connect.Views.OptionalDialog.extend({template: _.template($('#dvblink-player-tmpl').html())}))({name: 'dvblink-player'}));playerDialog.$el.on('keydown', function (event) {event.stopImmediatePropagation();});
playerDialog.showModal().always(function(){playerDialog.$el.off('keydown');});}
function addServerLine () {var $serverLine = $('<div/>')
.addClass('dbl-server-line')
.text(options.server.url + ':' + options.server.port)
.appendTo($('.dbl-footer'))
.on('click', function(){var electron=require('electron');var ipc=electron.ipcRenderer;ipc.sendSync('show-settings');});}
$(function(){addStdlnStyles();var electron=require('electron');var ipc=electron.ipcRenderer;var options=ipc.sendSync('get-settings');adaptSettingsDialog();
addServerLine();setTimeout(function(){Connect.common.Keyboard.clearMap().map(options.shortcuts);}, 400);});}).call(this,jQuery);