function Table ($table, options) {this._$table = $table;this._$body = $table.find('tbody');this._data=null;this._lastParams=null;var nop=function(){};this._options = {};_.each([
'emptyTableHelp', 'onAction', 'onAppend', 'onBeforeEdit', 'onBeforeSave', 'onEdit', 'onInputChange', 'onRemove',
'onRowSelect', 'onSave', 'onSave', 'onUpdateRowView', 'onUpdateRowView', 'onUpdateRowView', 'onUpdateRowView',
'onUpdateRowView', 'onUpdateRowView'
], _.bind(function (method) {this._options[method] = nop;}, this));_.extend(this._options, options);this._$table.on('click.table', '.tbl-append', _.bind(function (event) {this._$table.find('button').attr('disabled', true);var $row = $(this._options.editRowTemplate.call(this, this._options.emptyFields))
.addClass('tbl-new-row');this._$body.prepend($row);
this._selectRow($row, false);this._$table.addClass('tbl-editing');
this._options.onAppend.call(this, $row);this._options.onUpdateRowView.call(this, $row);this._updateHelpForEmptyTable();}, this));this._$body.on('click.table', 'tr', _.bind(function (event) {if(this._$table.hasClass('tbl-editing')){return;}if(!$(event.target).is('td')){return;}
this._selectRow($(event.currentTarget), true);}, this));this._$body.on('dblclick.table', 'tr', _.bind(function (event) {$(event.currentTarget).find('.tbl-edit').click();}, this));this._$body.on('click.table', '.tbl-action', _.bind(function (event) {var $element = $(event.currentTarget);var $row = $element.closest('tr');this._options.onAction.call(this, $element, $row);}, this));this._$body.on('click.table', '.tbl-remove', _.bind(function (event) {var $row = $(event.currentTarget).closest('tr');this._removeRow($row);
this._selectRow();this._options.onRemove.call(this, $row);this._updateHelpForEmptyTable();}, this));this._$body.on('click.table', '.tbl-edit', _.bind(function (event) {var $row = $(event.currentTarget).closest('tr');this._options.onBeforeEdit.call(this, $row);this._$table.find('button').attr('disabled', true);this._$table.addClass('tbl-editing');
$row.find('button').attr('disabled', false);var $newRow=this._editRow($row);this._selectRow($newRow, false);this._options.onEdit.call(this, $newRow);this._options.onUpdateRowView.call(this, $newRow);this._updateHelpForEmptyTable();}, this));this._$body.on('click.table', '.tbl-save', _.bind(function (event) {var $row = $(event.currentTarget).closest('tr');if(!this._options.onBeforeSave.call(this, $row, true)){return;}
this._$table.removeClass('tbl-editing');this._$table.find('button').attr('disabled', false);var $newRow=this._saveRow($row);this._selectRow($newRow, false);this._options.onSave.call(this, $newRow, true);this._options.onUpdateRowView.call(this, $newRow);this._updateHelpForEmptyTable();}, this));this._$body.on('click.table', '.tbl-cancel', _.bind(function (event) {var $row = $(event.currentTarget).closest('tr');var $newRow = $row.hasClass('tbl-new-row') ? this._removeRow($row) : this._rejectRow($row);this._selectRow($newRow, false);this._$table.removeClass('tbl-editing');
this._$table.find('button').attr('disabled', false);this._options.onSave.call(this, $newRow, false);this._options.onUpdateRowView.call(this, $newRow);this._updateHelpForEmptyTable();}, this));this._$body.on('change.table', 'input, select', _.bind(function (event) {this._options.onInputChange.call(this, $(event.target));}, this));this._options.onUpdateRowView.call(this, this._$table);}
Table.prototype._updateHelpForEmptyTable=function(){if(this._$body.find('tr').length < 1){$(this._options.emptyTableHelp.call(this))
.appendTo(this._$body);}else{this._$body.find('tr.cfg-empty-table-help').remove();}}
Table.prototype.selectRow=function (num) {var $tr=this._$body.find('tr');if($tr.length <= num){return;}
this._selectRow($($tr[0]), true);}
Table.prototype._selectRow=function ($row, fireEvent) {this._$body.find('.tbl-active').removeClass('tbl-active');if($row){if($row.hasClass('cfg-empty-table-help')) {return;}
$row.addClass('tbl-active');}if(fireEvent){this._options.onRowSelect.call(this, $row);}};Table.prototype.setData=function (data) {var self=this;this._$body
.scrollTop(0)
.empty();var params=_.map(data, _.bind(function (item) {var t=_.object(_.map(item,function (value,field) {return [field, self._options.plainObjectToShowObject(field,value)];}));
this._insertRow(t);return t;}, this));this._updateHelpForEmptyTable();};Table.prototype._insertRow=function (row) {var $row = $(this._options.rowTemplate.call(this,row))
.appendTo(this._$body);this._options.onUpdateRowView.call(this, $row);};
Table.prototype._removeRow=function ($row) {$row.remove();};
Table.prototype._editRow=function ($row) {var params=_.object(_.map($row.find('[data-field]'), _.bind(function (input) {var $input = $(input);var field = $input.attr('data-field');return [field, this._options.viewElementToPlainObject.call(this, field, $input)];}, this)));this._lastParams=params;var $result = $(this._options.editRowTemplate.call(this,params)).insertBefore($row);$row.remove();
this._options.onUpdateRowView.call(this, $row);return $result;};
Table.prototype._saveRow=function ($row) {var params=_.object(_.map($row.find('[data-field]'), _.bind(function (input) {var $input = $(input);var field = $input.attr('data-field');return [field, this._options.editElementToPlainObject.call(this, field, $input)];}, this)));params=_.object(_.map(params, _.bind(function (value,field) {return [field, this._options.plainObjectToShowObject.call(this,field,value)];}, this)));var $result = $(this._options.rowTemplate.call(this,params)).insertBefore($row);$row.remove();
this._options.onUpdateRowView.call(this, $row);return $result;};
Table.prototype._rejectRow=function ($row) {var params=_.object(_.map(this._lastParams, _.bind(function (value,field) {return [field, this._options.plainObjectToShowObject.call(this,field,value)];}, this)));var $result = $(this._options.rowTemplate.call(this,params)).insertBefore($row);$row.remove();
this._options.onUpdateRowView.call(this, $row);return $result;};
Table.prototype.getData=function(){return _.map(this._$body.find('tr').filter(':not(.cfg-empty-table-help)'), _.bind(function (row) {var $row = $(row);var rowParams=_.object(_.map($row.find('[data-field]'), _.bind(function (input) {var $input = $(input);var field = $input.attr('data-field');return [field, this._options.viewElementToPlainObject.call(this, field, $input)];}, this)));return rowParams;}, this));};