$(function(){$('#progress').dialog('open');var ASK_TIMEOUT=15000;var ASK_REQUEST_INTERVAL=1000;var STATUS_CHARS = {true: '✔',
false: '✘'};function StreamCheck (channels,timeout,channelCheckedCallback) {this._channels=channels;this._timeout=timeout;this._channelCheckedCallback=channelCheckedCallback;this._askRequestTimeout=null;this._startRequestXHR=null;this._askRequestXHR=null;this._askRequestHandle=null;this._askRequestTimer=null;}
StreamCheck.prototype.start=function(){this._nextChannel();};
StreamCheck.prototype.abort=function(){if(this._startRequestXHR){this._startRequestXHR.abort();this._startRequestXHR=null;}if(this._askRequestXHR){this._askRequestXHR.abort();this._askRequestXHR=null;this._stopRequest(this._askRequestHandle);}if(this._askRequestTimer){clearTimeout(this._askRequestTimer);this._askRequestTimer=null;this._stopRequest(this._askRequestHandle);}};StreamCheck.prototype._getNextChannel=function(){var firstChannel=_.first(this._channels);this._channels=_.tail(this._channels);return firstChannel;};
StreamCheck.prototype._nextChannel=function(){var channel=this._getNextChannel();if(!channel){streamCheckDialogClose();return;}
updateStreamCheckDialogStatus(channel.name);this._startRequestXHR=this._startRequest(channel, _.bind(function (response) {this._askRequest(response.handle, _.bind(function (reason,status) {this._channelCheckedCallback.call(this, channel.id, channel.ts, status);this._stopRequest(response.handle, _.bind(function(){this._nextChannel();}, this));}, this));}, this));};
StreamCheck.prototype._startRequest=function (channel,successCallback) {$('#stream-check-dialog').dialog('open');this._startRequestXHR = $.ajax({url: './start/',
dataType : 'json',
data: _.pick(channel, 'id', 'ts'),
timeout: 60000,
type: 'POST',
error: function (xhr,textStatus) {if(textStatus === 'abort'){return;}
show_info(l.c.internal_error);streamCheckDialogClose();},
success: successCallback,
complete: _.bind(function(){this._startRequestXHR=null;}, this)});return this._startRequestXHR;};
StreamCheck.prototype._checkTimeout=function (handle,completeCallback,response) {if(this._askRequestTimeout < new Date().getTime()){this._askRequestTimeout=null;completeCallback.call(this, 'timeout', response && response.status || null);return;}
this._askRequestTimer=setTimeout(_.bind(function(){this._askRequestTimer=null;this._askRequest(handle,completeCallback);}, this), ASK_REQUEST_INTERVAL);}
StreamCheck.prototype._askRequest=function (handle,completeCallback) {if(!this._askRequestTimeout){this._askRequestTimeout=new Date().getTime() + this._timeout;}
this._askRequestHandle=handle;this._askRequestXHR = $.ajax({url: './ask/',
dataType : 'json',
data: {handle: handle},
timeout: this._timeout,
type: 'POST',
error: _.bind(function (xhr,textStatus) {if(textStatus === 'abort'){return;}
this._checkTimeout(handle,completeCallback,null);}, this),
success:  _.bind(function (response) {updateStreamCheckDialogStatus(null, response.status);if(_.all(response.status)){this._askRequestTimeout=null;completeCallback.call(this, 'success', response.status);return;}
this._checkTimeout(handle,completeCallback,response);}, this),
complete: _.bind(function(){this._askRequestXHR=null;}, this)});return this._askRequestXHR;};
StreamCheck.prototype._stopRequest=function (handle,completeCallback) {return $.ajax({url: './stop/',
dataType : 'json',
data: {handle: handle},
timeout: 60000,
type: 'POST',
complete: _.bind(function(){if(_.isFunction(completeCallback)){completeCallback.call(this);}
this._askRequestHandle=null;}, this)});};
var $streamCheckDialog = $('#stream-check-dialog').dialog({autoOpen: false,
modal: true,
draggable: false,
resizable: false,
closeText: '',
width: 400,
closeOnEscape: false,
open: function(event,ui) {$(this).parent().find('a.ui-dialog-titlebar-close').hide();}});function updateStreamCheckDialogStatus (channel,status) {if(channel){$streamCheckDialog.find('.cfg-channel').text(channel);}
updateStatusField($streamCheckDialog, status);$streamCheckDialog.dialog('open');};function streamCheckDialogClose () {$streamCheckDialog.dialog('close');}
function updateStatusField ($parent, status) {var PAIR = {'psi_present': '.cfg-lock',
'stream_present': '.cfg-stream',
'stream_decrypted': '.cfg-decrypted'};_.each(PAIR,function (selector,field) {$parent.find(selector).text(status ? STATUS_CHARS[status[field]] : '');});}
function updatePhysicalChannelStatus ($physicals, id, ts, status) {var $physicalChannel = $physicals.find('.cfg-physical[data-id="' + id + '"][data-ts="' + ts + '"]');var $all = $('.cfg-physical');var index = $all.index($physicalChannel) - 3;if(index > 0){$all.get(index).scrollIntoView();}
updateStatusField($physicalChannel, status);if(status){$physicalChannel.find('.cfg-select').prop('checked', false).change();}}
var $timeout = $('.cfg-timeout').val(ASK_TIMEOUT / 1000);var $performCheckButton = $('#perform-check').button('option', 'disabled', true);var $streamCheckCancelButton = $('#stream-check-cancel-btn');var $physicals = $('.cfg-physicals');var $selectAll = $('.cfg-channels-header .cfg-select-all').on('change', function(){$physicals.find('.cfg-select')
.prop('checked', $(this).prop('checked'))
.change();});
$('.cfg-select').prop('checked', false);$physicals.find('.cfg-select').on('change', _.throttle(function(){var anySelect = $physicals.find('.cfg-select:checked').length > 0;$selectAll
.prop('checked', anySelect);$performCheckButton.button('option', 'disabled', !anySelect);}, 100));$physicals.find('.cfg-select').on('change', function(){$(this).closest('.cfg-physical').toggleClass('cfg-active', $(this).prop('checked'));});
$('.cfg-logical .cfg-name').on('click', function (event) {var $selectors = $(this).next('.cfg-physicals').find('.cfg-select');$(this).next('.cfg-physicals').find('.cfg-select').prop('checked', !_.any($selectors.filter(':checked'))).change();});
$physicals.find('.cfg-physical').on('click', function (event) {if($(event.target).is('.cfg-select')){return;}
var $select = $(this).find('.cfg-select');$select.prop('checked', !$select.prop('checked')).change();});
$('#perform-check').on('click', function(){var channels=_.map($physicals.find('.cfg-active'), function (channel) {var $channel = $(channel);return {id: $channel.attr('data-id'),
ts: $channel.attr('data-ts'),
name: $channel.find('.cfg-name').text()}});$physicals.find('.cfg-active >.cfg-value').html('&nbsp;');$('.cfg-physical.cfg-active').closest('.cfg-logical').get(0).scrollIntoView();
var timeout=parseInt($timeout.val(),10) * 1000 || ASK_TIMEOUT;var streamCheck=new StreamCheck(channels,timeout,function (id,ts,status) {updatePhysicalChannelStatus($physicals, id, ts, status);});
$streamCheckCancelButton
.off()
.on('click', function(){streamCheck.abort();streamCheckDialogClose();});streamCheck.start();});$(window).bind('beforeunload', function(){$('#progress').dialog('open');});
$('#progress').dialog('close');});